
// Graficzny miernik SWR V3.97b509
// + menu serwisowe
//  LCD 400x240

#define serial_number 8
#define soft_number "V3.97b509"
#define TOUCH_ORIENTATION  LANDSCAPE

#include <stdint.h>
#include <TouchScreen.h>
#include <Adafruit_GFX.h>
#include <UTFTGLUE.h>
#include <EEPROM.h>

UTFTGLUE myGLCD(0x7793, A2, A1, A3, A4, A0); //R61509V
extern uint8_t SmallFont[];

// MCUFRIEND UNO shield shares pins with the TFT.
#define YP A2
#define YM 7
#define XM A1
#define XP 6

//int lcdBacklight = 10;

// Define Pins used to control AD9850 DDS
const int SCLK = 10;
const int FQ_UD = 11;
const int SDAT = 12;
const int RESET = 13;

TouchScreen myTouch(XP, YP, XM, YM, 345);
TSPoint tp;
//TSPoint tp_poprzednie;

#define BLACK   0x0000
#define BLUE    0x001F
#define RED     0xF800
#define GREEN   0x07E0
#define CYAN    0x07FF
#define MAGENTA 0xF81F
#define YELLOW  0xFFE0
#define WHITE   0xFFFF
//#define ROZ     0xFD20
#define ROZ     0xFBE0
#define GRI     0xBDF7


// deklaracja zmiennych
word freq;
word skanFREQ;
byte skanFreq2;
word skanREZ;
byte pasmo;
word krok;
byte onMenu = 0;
byte pozMenu;
word freqStart ;
word num_steps = 450; // od 0 do 430 kroków sweep
word VSWR_poprzedni;
word VSWR;
boolean menu_otwarte = false;
boolean skan_on = false;
boolean skan_gotowy = false;
double fiku;
word skanVSWR;
word skanPOZYCJA;
word skanDuszek;
byte adres;
byte value;
byte kolor_bit;
byte k150;
byte k200;
byte k300;
byte k400;
byte kBAT;
word petla;


//***********************************************************************************
//         Malowanie dolnej skali częstotliwości
//***********************************************************************************
void skala() {
  word pk;
  word zk;
  word freq2;
  int x;
  int x2;
  freq2 = freq;
  myGLCD.setBackColor(255, 255, 255);
  myGLCD.setColor(0, 0, 0);
  freq2 = freq2 - krok * 2;
  x = 20;
  for (byte i = 0; i < 5; i++) {
    pk = freq2 / 10;
    zk = freq2 - pk * 10;
    if (pk > 9) {
      x2 = x - 12;
    }
    else {
      myGLCD.print(" ", x - 12, 224);
      x2 = x;
    }
    myGLCD.printNumI(pk, x2, 224);
    x += 12;
    myGLCD.print(".", x, 224);
    x += 12;
    myGLCD.printNumI(zk, x, 224);

    freq2 += krok;
    x += 56;
  }

}
//***************************************************************************
void kalibracja() {
  byte x = 8;
  myGLCD.clrScr();
  myGLCD.setTextSize(4);
  myGLCD.print("Calibration", 70, 10);
  myGLCD.setColor(255, 255, 0);
  myGLCD.fillRoundRect(20, 60, 100, 100); //50
  myGLCD.fillRoundRect(20, 120, 100, 160); //100
  myGLCD.fillRoundRect(20, 180, 100, 220); //150

  myGLCD.fillRoundRect(200, 60, 280, 100); //200
  myGLCD.fillRoundRect(200, 120, 280, 160); //300
  myGLCD.fillRoundRect(200, 180, 280, 220); //BAT

  myGLCD.setColor(0, 0, 255);
  myGLCD.setBackColor(255, 255, 0);
  myGLCD.print("50", 30 , 66);
  myGLCD.print("100", 22, 126);
  myGLCD.print("150", 22, 186);
  myGLCD.print("200", 204 , 66);
  myGLCD.print("300", 204, 126);
  myGLCD.print("BAT", 204, 186);
  myGLCD.setColor(255, 255, 255);
  myGLCD.drawRoundRect(20, 60, 100, 100); //50
  myGLCD.drawRoundRect(21, 61, 99, 99); //50
  myGLCD.drawRoundRect(20, 120, 100, 160); //100
  myGLCD.drawRoundRect(21, 121, 99, 159); //100
  myGLCD.drawRoundRect(20, 180, 100, 220); //150
  myGLCD.drawRoundRect(21, 181, 99, 219); //150
  myGLCD.drawRoundRect(200, 60, 280, 100); //200
  myGLCD.drawRoundRect(201, 61, 279, 99); //200
  myGLCD.drawRoundRect(200, 120, 280, 160); //300
  myGLCD.drawRoundRect(201, 121, 279, 159); //300
  myGLCD.drawRoundRect(200, 180, 280, 220); //BAT
  myGLCD.drawRoundRect(201, 181, 279, 219); //BAT
  k150 = EEPROM.read(31);
  k200 = EEPROM.read(32);
  k300 = EEPROM.read(33);
  k400 = EEPROM.read(34);
  kBAT = EEPROM.read(30);
  myGLCD.setColor(255, 255, 255);
  myGLCD.setBackColor(0, 0, 0);
  myGLCD.setTextSize(2);
  SetDDSFreq(1000000);
  delay(100);
  myGLCD.print("K=  ", 110, 140);
  myGLCD.printNumI(k150, 134, 140);
  myGLCD.print("K=  ", 110, 200);
  myGLCD.printNumI(k200, 134, 200);
  myGLCD.print("K=  ", 290, 80);
  myGLCD.printNumI(k300, 314, 80);
  myGLCD.print("K=  ", 290, 140);
  myGLCD.printNumI(k400, 314, 140);
  myGLCD.print("K=  ", 290, 200);
  myGLCD.printNumI(kBAT, 314, 200);

  do
  {
    readResistiveTouch();
    if ( tp.z > 20 && tp.z < 1000) {
      if (tp.x > 370 && tp.x < 500 && tp.y > 750 && tp.y < 900)kalibracja_50();
      if (tp.x > 560 && tp.x < 680 && tp.y > 750 && tp.y < 900)kalibracja_150();
      if (tp.x > 750 && tp.x < 850 && tp.y > 750 && tp.y < 900)kalibracja_200();
      if (tp.x > 380 && tp.x < 500 && tp.y > 400 && tp.y < 550)kalibracja_300();
      if (tp.x > 550 && tp.x < 680 && tp.y > 400 && tp.y < 550)kalibracja_400();
      if (tp.x > 740 && tp.x < 860 && tp.y > 400 && tp.y < 550)kalibracja_BAT();

    }

  } while (x > 0) ;
}
//***************************************************************************
void kalibracja_50() {
  word FOR;
  for (int i = 1; i < 31; i++) {
    SetDDSFreq(i * 1000000);
    delay(500);
    FOR = analogRead(A7);
    delay(100);
    myGLCD.print("F=", 110, 63);
    myGLCD.printNumI(i, 134, 63);
    myGLCD.print("V=", 110, 80);
    myGLCD.printNumI(FOR, 134, 80);
    byte freqLL = FOR;
    byte freqHH = FOR / 255;
    adres = (i * 2) + 60;
    EEPROM.write(adres, freqLL); //freq L
    EEPROM.write(adres + 1, freqHH); //freq H
  }
  myGLCD.print("*", 175, 63);
  delay(2000);
}
//**************************************************************************
void kalibracja_150() {
  SetDDSFreq(14000000);
  delay(100);
  petla = 0;
  do {
    petla++;
    pomiar_VSWR();
    delay(100);
    myGLCD.print("V=     ", 110, 123);
    myGLCD.printNumI(VSWR, 134, 123);
    myGLCD.print("K=   ", 110, 140);
    myGLCD.printNumI(k150, 134, 140);
    if (VSWR > 200)k150--;
    if (VSWR < 200)k150++;
    if (petla > 300) break;
  } while (VSWR != 200);
  myGLCD.print("*", 175, 123);
  EEPROM.write(31, k150);
}
//*********************************
void kalibracja_200() {
  SetDDSFreq(14000000);
  delay(100);
  petla = 0;
  do {
    petla++;
    pomiar_VSWR();
    delay(100);
    myGLCD.print("V=    ", 110, 183);
    myGLCD.printNumI(VSWR, 134, 183);
    myGLCD.print("K=   ", 110, 200);
    myGLCD.printNumI(k200, 134, 200);
    if (VSWR > 300)k200--;
    if (VSWR < 300)k200++;
    if (petla > 300) break;
  } while (VSWR != 300);
  myGLCD.print("*", 175, 183);
  EEPROM.write(32, k200);
}
//*********************************
void kalibracja_300() {
  SetDDSFreq(14000000);
  delay(100);
  petla = 0;
  do {
    petla++;
    pomiar_VSWR();
    delay(100);
    myGLCD.print("V=    ", 290, 63);
    myGLCD.printNumI(VSWR, 314, 63);
    myGLCD.print("K=   ", 290, 80);
    myGLCD.printNumI(k300, 314, 80);
    if (VSWR > 400)k300--;
    if (VSWR < 400)k300++;
    if (petla > 300) break;
  } while (VSWR != 400);
  myGLCD.print("*", 355, 63);
  EEPROM.write(33, k300);
}
//*********************************
void kalibracja_400() {
  SetDDSFreq(14000000);
  delay(100);
  petla = 0;
  do {
    petla++;
    pomiar_VSWR();
    delay(100);
    myGLCD.print("V=    ", 290, 123);
    myGLCD.printNumI(VSWR, 314, 123);
    myGLCD.print("K=   ", 290, 140);
    myGLCD.printNumI(k400, 314, 140);
    if (VSWR > 600)k400--;
    if (VSWR < 600)k400++;
    if (petla > 300) break;
  } while (VSWR != 600);
  myGLCD.print("*", 355, 123);
  EEPROM.write(34, k400);
}
//*********************************
void kalibracja_BAT() {
  word VBAT;
  petla = 0;
  do {
    petla++;
    VBAT = analogRead(A5);
    delay(100);
    VBAT = VBAT - (kBAT * 5);
    myGLCD.print("V=     ", 290, 183);
    myGLCD.printNumI(VBAT, 314, 183);
    myGLCD.print("K=   ", 290, 200);
    myGLCD.printNumI(kBAT, 314, 200);
    if (VBAT < 100)kBAT--;
    if (VBAT > 100)kBAT++;
    if (petla > 300) break;
  } while (VBAT != 100);
  myGLCD.print("*", 355, 183);
  EEPROM.write(30, kBAT);
}
//***************************************************************************
void readResistiveTouch(void)
{

  tp = myTouch.getPoint();
  pinMode(YP, OUTPUT);      //restore shared pins
  pinMode(XM, OUTPUT);
  digitalWrite(YP, HIGH);
  digitalWrite(XM, HIGH);
}

//***     OPEN Menu
//****************************************************************************
void openMenu(void) {

  switch (pozMenu) {
    case 1:
      myGLCD.setColor(255, 0, 255);
      myGLCD.fillRoundRect(330, 48, 395, 83); //band
      myGLCD.setColor(255, 255, 0);
      myGLCD.fillRoundRect(330, 91, 395, 126); //freq
      myGLCD.fillRoundRect(330, 134, 395, 169); //wide
      myGLCD.fillRoundRect(330, 177, 395, 213); //skan
      break;
    case 2:
      myGLCD.setColor(255, 0, 255);
      myGLCD.fillRoundRect(330, 91, 395, 126); //freq
      myGLCD.setColor(255, 255, 0);
      myGLCD.fillRoundRect(330, 134, 395, 169); //wide
      myGLCD.fillRoundRect(330, 48, 395, 83); //band
      myGLCD.fillRoundRect(330, 177, 395, 213); //skan
      break;
    case 3:
      myGLCD.setColor(255, 0 , 255);
      myGLCD.fillRoundRect(330, 134, 395, 169); //wide
      myGLCD.setColor(255, 255, 0);
      myGLCD.fillRoundRect(330, 91, 395, 126); //freq
      myGLCD.fillRoundRect(330, 48, 395, 83); //band
      myGLCD.fillRoundRect(330, 177, 395, 213); //skan
      break;
    case 4:
      myGLCD.setColor(255, 0 , 255);
      myGLCD.fillRoundRect(330, 177, 395, 213); //skan
      myGLCD.setColor(255, 255, 0);
      myGLCD.fillRoundRect(330, 91, 395, 126); //freq
      myGLCD.fillRoundRect(330, 134, 395, 169); //wide
      myGLCD.fillRoundRect(330, 48, 395, 83); //band
      break;
  }

  myGLCD.setColor(0, 0, 0);
  switch (pozMenu) {
    case 1:
      myGLCD.setBackColor(255, 0 , 255);
      myGLCD.print("BAND", 340, 59);
      myGLCD.setBackColor(255, 255, 0);
      myGLCD.print("FREQ", 340, 102);
      myGLCD.print("ZOOM", 340, 145);
      myGLCD.print("SKAN", 340, 188);
      break;
    case 2:
      myGLCD.setBackColor(255, 0 , 255);
      myGLCD.print("FREQ", 340, 102);
      myGLCD.setBackColor(255, 255, 0);
      myGLCD.print("BAND", 340, 59);
      myGLCD.print("ZOOM", 340, 145);
      myGLCD.print("SKAN", 340, 188);
      break;
    case 3:
      myGLCD.setBackColor(255, 0 , 255);
      myGLCD.print("ZOOM", 340, 145);
      myGLCD.setBackColor(255, 255, 0);
      myGLCD.print("BAND", 340, 59);
      myGLCD.print("FREQ", 340, 102);
      myGLCD.print("SKAN", 340, 188);
      break;
    case 4:
      myGLCD.setBackColor(255, 0 , 255);
      myGLCD.print("SKAN", 340, 188);
      myGLCD.setBackColor(255, 255, 0);
      myGLCD.print("BAND", 340, 59);
      myGLCD.print("FREQ", 340, 102);
      myGLCD.print("ZOOM", 340, 145);
      break;
  }
  myGLCD.setColor(0, 0, 255);
  myGLCD.drawRoundRect(329, 4, 396, 40);
  myGLCD.drawRoundRect(330, 5, 395, 39);

  menu_otwarte = true;
  delay(400);
}
//     ********   CLOSE Menu
//******************************************************
void closeMenu(void) {
  myGLCD.setColor(255, 255, 255);
  myGLCD.fillRect(330, 48, 395, 213); // kasowanie klawiszy

  myGLCD.setColor(255, 255, 255);
  myGLCD.drawRoundRect(329, 4, 396, 40);
  myGLCD.setColor(0, 255, 0);
  myGLCD.drawRoundRect(330, 5, 395, 39);

  myGLCD.drawFastHLine(330, 72, 65, GREEN);
  myGLCD.drawFastHLine(330, 100, 65, GREEN);
  myGLCD.drawFastHLine(330, 128, 65, GREEN);
  myGLCD.drawFastHLine(330, 156, 65, GREEN);
  myGLCD.drawFastHLine(330, 184, 65, GREEN);
  myGLCD.drawFastHLine(330, 212, 65, GREEN);
  myGLCD.drawFastVLine(357, 45, 167, GREEN);

  menu_otwarte = false;
  delay(400);

}
//******************************************************
void setup()
{
  // Configiure DDS control pins for digital output
  pinMode(FQ_UD, OUTPUT);
  pinMode(SCLK, OUTPUT);
  pinMode(SDAT, OUTPUT);
  pinMode(RESET, OUTPUT);
  // piny do odczytu swr-a
  pinMode(A7, INPUT);
  pinMode(A6, INPUT);
  // Reset the DDS
  digitalWrite(RESET, HIGH);
  digitalWrite(RESET, LOW);

  pinMode(A0, OUTPUT);
  digitalWrite(A0, HIGH);
  myGLCD.InitLCD(TOUCH_ORIENTATION);
  myGLCD.clrScr();
  myGLCD.setFont(SmallFont);
  // myGLCD.fillScreen(WHITE);//  kolor biały cały
  myGLCD.invertDisplay(false); // soft
  myGLCD.clrScr();
  startup();
  skala();
}
//***********************************************************
void startup()
{
  byte value;
  byte x = 0;
  myGLCD.setColor(255, 255, 0);
  myGLCD.setBackColor(0, 0, 0);
  myGLCD.setTextSize(10);
  myGLCD.print("SWR", 60, 40);
  myGLCD.setColor(0, 255, 0);
  myGLCD.setTextSize(4);
  myGLCD.print("METER", 165, 120);
  myGLCD.setColor(255, 40, 0);
  myGLCD.setTextSize(2);
  myGLCD.print("By SQ1GU", 240, 160);
  myGLCD.setColor(255, 255, 255);
  myGLCD.setTextSize(1);
  myGLCD.print("S", 8, 16);
  myGLCD.print(soft_number, 10 , 220);
  myGLCD.fillCircle( 20, 20, 2);

  do
  {
    readResistiveTouch();
    if ( tp.z > 20 && tp.z < 1000) {
      if (tp.x < 280 && tp.y > 820)kalibracja();
    }
    delay(20);
    x++;
  } while (x < 100);

  myGLCD.fillScreen(WHITE);//  kolor biały cały

  myGLCD.drawFastVLine(20, 40, 180, BLACK);
  myGLCD.drawFastVLine(21, 40, 180, BLACK);
  myGLCD.drawFastHLine(20, 218, 377, BLACK);
  myGLCD.drawFastHLine(20, 219, 377, BLACK);
  //kreski na pionowej osi
  myGLCD.drawFastHLine(18, 44, 6, BLACK);
  myGLCD.drawFastHLine(18, 45, 6, BLACK);
  myGLCD.drawFastHLine(18, 72, 6, BLACK);
  myGLCD.drawFastHLine(18, 73, 6, BLACK);
  myGLCD.drawFastHLine(18, 100, 6, BLACK);
  myGLCD.drawFastHLine(18, 101, 6, BLACK);
  myGLCD.drawFastHLine(18, 128, 6, BLACK);
  myGLCD.drawFastHLine(18, 129, 6, BLACK);
  myGLCD.drawFastHLine(18, 156, 6, BLACK);
  myGLCD.drawFastHLine(18, 157, 6, BLACK);
  myGLCD.drawFastHLine(18, 184, 6, BLACK);
  myGLCD.drawFastHLine(18, 185, 6, BLACK);
  myGLCD.drawFastHLine(18, 212, 6, BLACK);
  myGLCD.drawFastHLine(18, 213, 6, BLACK);
  // kreski na poziomej osi
  myGLCD.drawFastVLine(37, 216, 6, BLACK);
  myGLCD.drawFastVLine(117, 216, 6, BLACK);
  myGLCD.drawFastVLine(197, 216, 6, BLACK);
  myGLCD.drawFastVLine(277, 216, 6, BLACK);
  myGLCD.drawFastVLine(357, 216, 6, BLACK);
  myGLCD.drawFastVLine(38, 216, 6, BLACK);
  myGLCD.drawFastVLine(118, 216, 6, BLACK);
  myGLCD.drawFastVLine(198, 216, 6, BLACK);
  myGLCD.drawFastVLine(278, 216, 6, BLACK);
  myGLCD.drawFastVLine(358, 216, 6, BLACK);

  myGLCD.drawFastVLine(77, 217, 4, BLACK);
  myGLCD.drawFastVLine(157, 217, 4, BLACK);
  myGLCD.drawFastVLine(237, 217, 4, BLACK);
  myGLCD.drawFastVLine(317, 217, 4, BLACK);
  myGLCD.drawFastVLine(78, 217, 4, BLACK);
  myGLCD.drawFastVLine(158, 217, 4, BLACK);
  myGLCD.drawFastVLine(238, 217, 4, BLACK);
  myGLCD.drawFastVLine(318, 217, 4, BLACK);

  //cyfry - skala swr
  myGLCD.setColor(0, 0, 0);
  myGLCD.setBackColor(255, 255, 255);
  myGLCD.setTextSize(2);
  myGLCD.print("1", 2, 206);
  myGLCD.print("2", 2, 148);
  myGLCD.print("3", 2, 122);
  myGLCD.print("4", 2, 94);
  myGLCD.print("6", 2, 66);
  myGLCD.setTextSize(1);
  myGLCD.print("1.5", 0, 181);
  myGLCD.drawCircle( 5, 44, 3);
  myGLCD.drawCircle( 12, 44, 3);

  //************************************ bateryjka
  myGLCD.drawRect(8, 2, 60, 21);
  myGLCD.drawRect(9, 3, 59, 20);
  myGLCD.drawFastVLine(58, 2, 20, BLACK);
  myGLCD.drawFastVLine(5, 7, 10, BLACK);
  myGLCD.drawFastVLine(6, 7, 10, BLACK);
  myGLCD.drawFastVLine(7, 7, 10, BLACK);
  //***********************************************
  // klawisze poziome
  myGLCD.setColor(255, 255, 0); //żółty kolor
  myGLCD.fillRoundRect(135, 6, 190, 39); //lewo
  myGLCD.fillRoundRect(200, 6, 255, 39); //prawo
  myGLCD.fillRoundRect(330, 6, 395, 39); //setup

  myGLCD.setColor(0, 0, 0);
  myGLCD.setBackColor(255, 255, 0);
  myGLCD.setTextSize(2);
  myGLCD.print("MENU", 339, 17);
  myGLCD.print("<<<", 142, 17);
  myGLCD.print(">>>", 209, 17);
  myGLCD.setColor(0, 255, 0); // zielona obwódka
  myGLCD.drawRoundRect(135, 5, 190, 39);
  myGLCD.drawRoundRect(200, 5, 255, 39);
  myGLCD.drawRoundRect(330, 5, 395, 39);
  pomiar_baterii();
  // siatka zielona
  myGLCD.drawFastHLine(37, 44, 360, GREEN);
  myGLCD.drawFastHLine(37, 72, 360, GREEN);
  myGLCD.drawFastHLine(37, 100, 360, GREEN);
  myGLCD.drawFastHLine(37, 128, 360, GREEN);
  myGLCD.drawFastHLine(37, 156, 360, GREEN);
  myGLCD.drawFastHLine(37, 184, 360, GREEN);
  myGLCD.drawFastHLine(37, 212, 360, GREEN);

  myGLCD.drawFastVLine(37, 45, 167, GREEN);
  myGLCD.drawFastVLine(77, 45, 167, GREEN);
  myGLCD.drawFastVLine(117, 45, 167, GREEN);
  myGLCD.drawFastVLine(157, 45, 167, GREEN);
  myGLCD.drawFastVLine(197, 45, 167, GREEN);
  myGLCD.drawFastVLine(237, 45, 167, GREEN);
  myGLCD.drawFastVLine(277, 45, 167, GREEN);
  myGLCD.drawFastVLine(317, 45, 167, GREEN);
  myGLCD.drawFastVLine(357, 45, 167, GREEN);
  myGLCD.drawFastVLine(397, 45, 167, GREEN);

  //  odczyt zawartości eepromu
  //***************************************************
  value = EEPROM.read(8);
  if (value != 13) {
    // inicjalizacja pustego eepromu
    EEPROM.write(8, 13); // dane są
    freq = 37;
    krok = 1;
    pasmo = 2;
    pozMenu = 2;
    EEprom_zapis();
    EEPROM.write(40, 142);
    EEPROM.write(41, 0);
    EEPROM.write(42, 10);
    EEPROM.write(50, 212);
    EEPROM.write(51, 0);
    EEPROM.write(52, 10);
    EEPROM.write(6, 0);
    EEPROM.write(31, 65);//k150
    EEPROM.write(32, 54);//k200
    EEPROM.write(33, 76);//k300
    EEPROM.write(34, 49);//k400
    EEPROM.write(30, 130);//kBAT
  }
  pasmo = EEPROM.read(23);
  witchBand();
  pozMenu = EEPROM.read(24);
  EEprom_odczyt();
  k150 = EEPROM.read(31);
  k200 = EEPROM.read(32);
  k300 = EEPROM.read(33);
  k400 = EEPROM.read(34);
  kBAT = EEPROM.read(30);

  myGLCD.setColor(0, 0, 0);
  myGLCD.setBackColor(255, 255, 255);
  myGLCD.setTextSize(2);
  if (pozMenu == 1) myGLCD.print("BAND", 270, 17);
  else if (pozMenu == 2) myGLCD.print("FREQ", 270, 17);
  else if (pozMenu == 3) myGLCD.print("ZOOM", 270, 17);
  else if (pozMenu == 4) {
    myGLCD.print("SKAN", 270, 17);
    skan_on = true;
  }
  myGLCD.invertDisplay(kolor_bit);
}
//**************************************************
void EEprom_zapis() {
  byte freqLL = freq;
  byte freqHH = freq / 255;
  adres = 20;
  if (pasmo == 10) adres = 40;
  if (pasmo == 11) adres = 50;
  EEPROM.write(adres, freqLL); //freq L
  EEPROM.write(adres + 1, freqHH); //freq H
  EEPROM.write(adres + 2, krok); //krok
  EEPROM.write(23, pasmo);  // pasmo
  EEPROM.write(24, pozMenu);  //menu pozycja
  EEPROM.write(6, kolor_bit);  //kolor LCD
}
//*************************************************
void EEprom_odczyt() {
  adres = 20;
  if (pasmo == 10) adres = 40;
  if (pasmo == 11) adres = 50;
  value = EEPROM.read(adres + 1);
  freq = value * 255;
  value = EEPROM.read(adres);
  freq = freq + value;
  krok = EEPROM.read(adres + 2);
  kolor_bit = EEPROM.read (6);
}
//*****************  Pętla główna *****************************************
void loop()
{
  readResistiveTouch();

  //if(nacisnieto(5,20)){
  if ( tp.z > 100 && tp.z < 900) {
    if (tp.x < 300 && tp.y < 300)menuON();
    if (tp.x > 350 && tp.x < 450 && tp.y < 300 && menu_otwarte == true)bandON();
    if (tp.x > 480 && tp.x < 580 && tp.y < 300 && menu_otwarte == true)genON();
    if (tp.x > 600 && tp.x < 700 && tp.y < 300 && menu_otwarte == true)stepON();
    if (tp.x > 750 && tp.x < 850 && tp.y < 300 && menu_otwarte == true)skanON();

    if (tp.x < 300 && tp.y > 580 && tp.y < 700)freqDown();
    if (tp.x < 300 && tp.y > 450 && tp.y < 560)freqUp();
    if (tp.x < 280 && tp.y > 820)kolor();
    EEprom_zapis();
    /*
        myGLCD.print("   ", 120, 100);
        myGLCD.printNumI(tp.x, 120, 100);
        myGLCD.print("   ", 120, 150);
        myGLCD.printNumI(tp.z, 120, 150);
    */
  }

  if (menu_otwarte == false) {
    sweep();
    pomiar_VSWR();
    maluj_wykres();
  }
  if (num_steps == 360) {
    pomiar_baterii();
    if (pozMenu == 4 && pasmo < 10) {
      wylicz_SWR();
      maluj_wynikSWR();
      skanVSWR = 600;
    }
  }

  /*
    if (skan_on == true) {
    if (skan_gotowy == true) {
      maluj_wynikSWR();
      skanVSWR = 600;
      skan_gotowy = false;
    }
    else {
      wylicz_SWR();
    }

    }
  */

}
//*************************************************************************
void kolor() {
  if (kolor_bit > 0) {
    kolor_bit = 0;
  }
  else {
    kolor_bit = 1;
  }
  myGLCD.invertDisplay(kolor_bit);
  delay(500);

}
//**************************************************************************
//   Odczytanie wartości analogowych i wyliczenie VSWR-a
void pomiar_VSWR() {

  word FOR;
  word REF;
  unsigned long VSWR2;
  unsigned long VSWR3;


  REF = analogRead(A6);
  FOR = analogRead(A7);

  //****************************
  // Calculate VSWR
  if (REF >= FOR) {
    VSWR2 = 3000;
  } else {
    VSWR2 = FOR + REF;
    VSWR2 = VSWR2 * 100;
    VSWR = FOR - REF;
    VSWR2 = VSWR2 / VSWR;
    if (VSWR2 > 3000)VSWR2 = 3000;
  }
  VSWR3 = VSWR2;
  // korekcja na charakterystyke detektora
  VSWR2 = VSWR2 * VSWR3;
  VSWR3 = VSWR2 / 100;
  VSWR = VSWR3;
  if (VSWR > 150) {
    VSWR2 = VSWR - 150;
    VSWR2 = VSWR2 * k150;
    VSWR3 = VSWR2 / 100 + 150;
    VSWR = VSWR3;
  }
  if (VSWR > 200) {
    VSWR2 = VSWR - 200;
    VSWR2 = VSWR2 * k200;
    VSWR3 = VSWR2 / 100 + 200;
    VSWR = VSWR3;
  }
  if (VSWR > 300) {
    VSWR2 = VSWR - 300;
    VSWR2 = VSWR2 * k300;
    VSWR3 = VSWR2 / 100 + 300;
    VSWR = VSWR3;
  }
  if (VSWR > 400) {
    VSWR2 = VSWR - 400;
    VSWR2 = VSWR2 * k400;
    VSWR3 = VSWR2 / 100 + 400;
    VSWR = VSWR3;
  }

  //****************************
  // skanowanie minimum swr-a
  if (VSWR < skanVSWR) {
    skanVSWR = VSWR;
    skanREZ = FOR;
    skanPOZYCJA = num_steps;
  }

}
//******************************************************************************
void maluj_wykres() {
  if (VSWR > 1000)VSWR = 1000;
  if (VSWR > 200) {
    VSWR = VSWR - 200;
    VSWR = VSWR / 2 + 200;
  }
  if (VSWR > 300) {
    VSWR = VSWR - 300;
    VSWR = VSWR / 2 + 300;
  }
  if (VSWR > 350) {
    VSWR = VSWR - 350;
    VSWR = VSWR / 2 + 350;
  }
  if (VSWR > 400)VSWR = 400;

  VSWR = map(VSWR, 100, 400, 212, 44);
  /* VSWR = 0 - VSWR;
    VSWR -= 65036;
    VSWR = ((VSWR * 7) / 10) - 13;
    if (VSWR < 62)VSWR = 62;
    if (VSWR > 267)VSWR = 267;
  */
  if (VSWR > 212)VSWR = 212;
  byte poprawka;
  if (num_steps == 0) {
    VSWR_poprzedni = VSWR;
    poprawka = 36;
  } else {
    poprawka = 35;
  }

  if (skan_on == true) {
    if  (num_steps > 114 && num_steps < 210) {
      myGLCD.drawFastVLine(num_steps + 36, 97, 117, WHITE ); // kasowanie poprzedniej lini
      myGLCD.drawFastVLine(num_steps + 37, 97, 117, WHITE); // kasowanie poprzedniej lini
      if (num_steps == 121)myGLCD.drawFastVLine(157, 100, 112, GREEN);
      if (num_steps == 161)myGLCD.drawFastVLine(197, 100, 112, GREEN);
      if (num_steps == 201)myGLCD.drawFastVLine(237, 100, 112, GREEN);
    }
    else {
      myGLCD.drawFastVLine(num_steps + 36, 45, 169, WHITE); // kasowanie poprzedniej lini
      myGLCD.drawFastVLine(num_steps + 37, 45, 169, WHITE); // kasowanie poprzedniej lini
      myGLCD.setColor(0, 255, 0);
      myGLCD.drawPixel(num_steps + poprawka , 72);
    }
  }

  if (skan_on == false) {
    myGLCD.drawFastVLine(num_steps + 36, 45, 169, WHITE); // kasowanie poprzedniej lini
    myGLCD.drawFastVLine(num_steps + 37, 45, 169, WHITE); // kasowanie poprzedniej lini
    if (num_steps == 121)myGLCD.drawFastVLine(157, 45, 167, GREEN);
    if (num_steps == 161)myGLCD.drawFastVLine(197, 45, 167, GREEN);
    if (num_steps == 201)myGLCD.drawFastVLine(237, 45, 167, GREEN);
    myGLCD.setColor(0, 255, 0);
    myGLCD.drawPixel(num_steps + poprawka , 72);
  }

  myGLCD.setColor(0, 255, 0);
  myGLCD.drawPixel(num_steps + poprawka , 212);
  myGLCD.drawPixel(num_steps + poprawka , 184); // malowanie poziomych kresek zielonych
  myGLCD.drawPixel(num_steps + poprawka , 156);
  myGLCD.drawPixel(num_steps + poprawka , 128);
  myGLCD.drawPixel(num_steps + poprawka , 100);
  myGLCD.drawPixel(num_steps + poprawka , 44);

  if (num_steps == 1)myGLCD.drawFastVLine(37, 45, 167, GREEN);
  if (num_steps == 41)myGLCD.drawFastVLine(77, 45, 167, GREEN);
  if (num_steps == 81)myGLCD.drawFastVLine(117, 45, 167, GREEN);
  if (num_steps == 241)myGLCD.drawFastVLine(277, 45, 167, GREEN);
  if (num_steps == 281)myGLCD.drawFastVLine(317, 45, 167, GREEN);
  if (num_steps == 321)myGLCD.drawFastVLine(357, 45, 167, GREEN);

  myGLCD.setColor(0, 0, 255);
  if (skan_on == true && VSWR < 100 && num_steps > 114 && num_steps < 210) {
  }
  else {
    myGLCD.drawLine(num_steps + poprawka , VSWR_poprzedni, num_steps + 36, VSWR); // malowanie nowej lini
    myGLCD.drawLine(num_steps + poprawka + 1 , VSWR_poprzedni, num_steps + 37, VSWR); // malowanie nowej lini
    myGLCD.drawLine(num_steps + poprawka, VSWR_poprzedni + 1, num_steps + 36, VSWR + 1); // malowanie nowej lini
  }
  VSWR_poprzedni = VSWR;
  /*  myGLCD.print("    ",100,100);
    myGLCD.print("    ",100,120);
    myGLCD.printNumI(FOR,100, 100);
    myGLCD.printNumI(REF,100, 120);
    delay(100);
  */

}
//**************************************************************************
// *****************  przeliczenie i wysłanie danej do DDS-a ***************
void sweep() {
  num_steps ++;
  double krok2 = krok;
  fiku = fiku + krok2 * 1250 ;
  if (num_steps > 360) {
    num_steps = 0;
    freqStart = freq;
    freqStart = freqStart - krok * 2;
    fiku = freqStart * 100;
    fiku = fiku * 1000;
  }
  SetDDSFreq(fiku);
  if (num_steps == 0) delay (100);
}
//**************************************************************************
void SetDDSFreq(double Freq_Hz) {
  // Calculate the DDS word - from AD9851 Datasheet
  int32_t f = Freq_Hz * 4294967295 / 180000000;//180000000;
  // Send one byte at a time
  for (int b = 0; b < 4; b++, f >>= 8) {
    send_byte(f & 0xFF);
  }
  // 5th byte needs to be zeros
  send_byte(1);
  // Strobe the Update pin to tell DDS to use values
  digitalWrite(FQ_UD, HIGH);
  digitalWrite(FQ_UD, LOW);
}

void send_byte(byte data_to_send) {
  // Bit bang the byte over the SPI bus
  for (int i = 0; i < 8; i++, data_to_send >>= 1) {
    // Set Data bit on output pin
    digitalWrite(SDAT, data_to_send & 0x01);
    // Strobe the clock pin
    digitalWrite(SCLK, HIGH);
    digitalWrite(SCLK, LOW);
  }
}
//*****************************************************************************
void bandON() {
  pozMenu = 1;
  openMenu();
  myGLCD.setColor(0, 0, 0);
  myGLCD.setBackColor(255, 255, 255);
  myGLCD.setTextSize(2);
  myGLCD.print("BAND", 270, 17);
  skan_on = false;
  delay(200);
  closeMenu();
}
void genON() {
  pozMenu = 2;
  openMenu();
  myGLCD.setColor(0, 0, 0);
  myGLCD.setBackColor(255, 255, 255);
  myGLCD.setTextSize(2);
  myGLCD.print("FREQ", 270, 17);
  skan_on = false;
  delay(200);
  closeMenu();
}
void stepON() {
  pozMenu = 3;
  openMenu();
  myGLCD.setColor(0, 0, 0);
  myGLCD.setBackColor(255, 255, 255);
  myGLCD.setTextSize(2);
  myGLCD.print("ZOOM", 270, 17);
  skan_on = false;
  delay(200);
  closeMenu();
}
void skanON() {
  pozMenu = 4;
  openMenu();
  num_steps = 500;
  skanVSWR = 600;
  myGLCD.setColor(0, 0, 0);
  myGLCD.setBackColor(255, 255, 255);
  myGLCD.print("SKAN", 270, 17);
  skan_on = true;
  skan_gotowy = false;
  delay(200);
  closeMenu();
  myGLCD.setColor(255, 255, 255);
  myGLCD.fillRect(152, 45, 245, 96);
}

void menuON()
{
  if (menu_otwarte == true)
  {
    closeMenu();
  }
  else
  {
    openMenu();
  }
}
//*****************************************************************
//             maluj duszka skanFREQ , skanDuszek, skanVSWR
//*****************************************************************
void maluj_wynikSWR() {
  byte xpozycja;
  byte spoz;
  word skan2;
  word skan3;

  myGLCD.setColor(0, 0, 0);
  myGLCD.setBackColor(255, 255, 255);
  if (skanVSWR < 350) {
    myGLCD.print("F= ", 152, 46);
    myGLCD.print("SWR= ", 152, 63);
    myGLCD.print("R=", 152, 80);
    myGLCD.print("ohm", 212, 80);

    if (skanFREQ > 9999) {
      xpozycja = 176;
    }
    else {
      xpozycja = 186;
    }
    myGLCD.printNumI(skanFREQ, xpozycja + 12, 46);
    myGLCD.printNumI(skanFREQ / 1000, xpozycja, 46);
    myGLCD.print(".", 198, 46);

    myGLCD.printNumI(skanVSWR, 212, 63);
    myGLCD.printNumI(skanVSWR / 100, 202, 63);
    myGLCD.print(".", 212, 63);


    wyliczREZ();
    if (skanREZ > 99) {
      xpozycja = 176;
    }
    else {
      xpozycja = 188;
      myGLCD.print(" ", 176, 80);
    }
    myGLCD.printNumI(skanREZ, xpozycja, 80);
  }
  else {
    myGLCD.setColor(255, 255, 255);
    myGLCD.fillRect(152, 46, 245, 96);
    myGLCD.setColor(0, 0, 0);
    myGLCD.print("HI SWR", 160, 63);
  }

  skan_gotowy = false;
}
//*****************************************************************
void wyliczREZ()
{
  word value1;
  word value2;
  skanFreq2 = skanFREQ / 1000;
  byte adres = (skanFreq2 * 2) + 60;
  value1 = EEPROM.read(adres + 1);
  value2 = value1 * 255;
  value1 = EEPROM.read(adres);
  value2 = value2 + value1;
  if (value2 <= skanREZ) {
    skanREZ = (5 * skanVSWR) / 10;
  }
  else {
    skanREZ = 5000 / skanVSWR;
  }
}
//*****************************************************************
//          wylicz_SWR ();
//*****************************************************************
void wylicz_SWR() {
  if (skanVSWR < 400) {
    freqStart = freq;
    freqStart = freqStart - krok * 2;
    freqStart = freqStart * 100 + skanPOZYCJA * (krok * 1.25);
    skanFREQ = freqStart;
    freqStart = freqStart / 100;
    if (freq > freqStart++)  freq = freqStart;
    if (freq < freqStart--)  freq = freqStart;
    // if (krok>4) krok=2;
    skala();
  }
  skan_gotowy = true;
}
//*****************************************************************
//     freq lub inne UP ***
void freqUp(void) {
  myGLCD.setColor(0, 0, 255);
  myGLCD.drawRoundRect(199, 4, 256, 40);
  myGLCD.drawRoundRect(200, 5, 255, 39);

  word pomocna;
  switch (pozMenu) {
    case 1:
      pasmo ++;
      if (pasmo > 11) pasmo = 1;
      witchBand();
      break;
    case 2:
      freq++;
      if (freq > 550)freq = 550;
      break;
    case 3:
      krok--;
      if (krok == 0) krok = 1;
      break;
    case 4:
      pasmo ++;
      if (pasmo > 11)pasmo = 1;
      witchBand();
      break;
  }
  skala();
  delay(150);
  myGLCD.setColor(0, 255, 0);
  myGLCD.drawRoundRect(200, 5, 255, 39);
  myGLCD.setColor(255, 255, 255);
  myGLCD.drawRoundRect(199, 4, 256, 40);
}
//      freq lub inne w dół   ***
//**************************************************************
void freqDown(void) {
  myGLCD.setColor(0, 0, 255);
  myGLCD.drawRoundRect(134, 5, 191, 40);
  myGLCD.drawRoundRect(135, 6, 190, 39);
  int pomocna;
  switch (pozMenu) {
    case 1:
      pasmo --;
      if (pasmo == 0)pasmo = 11;
      witchBand();
      break;
    case 2:
      freq--;
      pomocna = freq - krok * 2;
      if (pomocna < 10)freq++;
      break;
    case 3:
      krok++;
      pomocna = freq - krok * 2;
      if (pomocna < 10) krok--;
      break;
    case 4:
      pasmo --;
      if (pasmo == 0)pasmo = 11;
      witchBand();
      break;
  }
  skala();
  delay(100);
  myGLCD.setColor(0, 255, 0);
  myGLCD.drawRoundRect(135, 6, 190, 39);
  myGLCD.setColor(255, 255, 255);
  myGLCD.drawRoundRect(134, 5, 191, 40);
}
//   zmiana pasma ****
//************************************************************
void witchBand() {

  myGLCD.setColor(0, 0, 0);
  myGLCD.setBackColor(255, 255, 255);
  myGLCD.setTextSize(2);
  if (krok > 6) krok = 4;
  switch (pasmo) {
    case 1:
      freq = 18;
      myGLCD.print("160m", 75, 17);
      break;
    case 2:
      freq = 37;
      myGLCD.print(" 80m", 75, 17);
      break;
    case 3:
      freq = 71;
      myGLCD.print(" 40m", 75, 17);
      break;
    case 4:
      freq = 101;
      myGLCD.print(" 30m", 75, 17);
      break;
    case 5:
      freq = 142;
      myGLCD.print(" 20m", 75, 17);
      break;
    case 6:
      freq = 181;
      myGLCD.print(" 17m", 75, 17);
      break;
    case 7:
      freq = 212;
      myGLCD.print(" 15m", 75, 17);
      break;
    case 8:
      freq = 249;
      myGLCD.print(" 12m", 75, 17);
      break;
    case 9:
      freq = 284;
      myGLCD.print(" 10m", 75, 17);
      break;
    case 10:
      EEprom_odczyt();
      myGLCD.print("ANT1", 75, 17);
      break;
    case 11:
      EEprom_odczyt();
      myGLCD.print("ANT2", 75, 17);
      break;

  }
  num_steps = 500;
  skanVSWR = 600;
}
//***********************************************
//Pomiar napięcia baterii
void pomiar_baterii() {
  word VBAT;
  word ystart;
  VBAT = analogRead(A5);
  delay(10);
  VBAT = VBAT - (kBAT * 5);
  if (VBAT > 200)VBAT = 0;
  if (VBAT > 100 && VBAT < 200) VBAT = 100;

  myGLCD.setColor(0, 0, 0);
  myGLCD.setBackColor(200, 230, 0);
  myGLCD.print("    ", 10, 4);
  if (VBAT < 10) ystart = 35;
  if (VBAT >= 10) ystart = 23;
  if (VBAT >= 100) ystart = 11;

  myGLCD.print("  ", 11, 5);
  myGLCD.printNumI(VBAT, ystart, 5);
  myGLCD.print("%", 47, 5);
}
//*************************************************
